package de.ozgcloud.vorgang.common.migration;

import java.util.List;

import org.springframework.data.mongodb.core.MongoOperations;

import io.mongock.api.annotations.ChangeUnit;
import io.mongock.api.annotations.Execution;
import io.mongock.api.annotations.RollbackExecution;

@ChangeUnit(id = "2023-11-20 15:20:00 OZG-4189-OZG-4601", order = "M002", author = "mkuester", runAlways = true)
public class M002_UpdateClientNameInGridFs { // NOSONAR

	static final String GRID_FS_FILE_COLLECTION = "fs.files";
	static final String OLD_CLIENT_NAME = "goofy";
	static final String NEW_CLIENT_NAME = "Alfa";

	@Execution
	public void doMigration(MongoOperations db) {
		db.getCollection(GRID_FS_FILE_COLLECTION).updateMany(
				RenameUtil.createMetadataClientMatchingDocument(OLD_CLIENT_NAME),
				List.of(
						RenameUtil.createSetFilenameOperation(OLD_CLIENT_NAME, NEW_CLIENT_NAME),
						RenameUtil.createSetClientDocument(NEW_CLIENT_NAME)));
	}

	@RollbackExecution
	public void rollback() {
		// kein rollback implementiert
	}
}