package de.ozgcloud.vorgang.registry;

import java.util.List;

import org.springframework.boot.autoconfigure.condition.ConditionalOnProperty;
import org.springframework.stereotype.Service;

import de.ozgcloud.vorgang.VorgangManagerProperties;
import lombok.RequiredArgsConstructor;
import lombok.extern.log4j.Log4j2;

@Service
@Log4j2
@RequiredArgsConstructor
@ConditionalOnProperty(prefix = "ozgcloud.zufi-manager", name = { "address" })
class RegistryService {

	private final VorgangManagerProperties vorgangManagerProperties;
	private final ZufiRemoteService zufiRemoteService;

	public void registerVorgangManager(List<String> supportedOrganisationsEinheiten) {
		if (supportedOrganisationsEinheiten.isEmpty()) {
			LOG.warn("Missing organisationseinheitenIds. Skipping registration.");
			return;
		}
		zufiRemoteService.registerVorgangManager(supportedOrganisationsEinheiten, vorgangManagerProperties.getAddress());
	}
}
