/*
 * Copyright (C) 2022 Das Land Schleswig-Holstein vertreten durch den
 * Ministerpräsidenten des Landes Schleswig-Holstein
 * Staatskanzlei
 * Abteilung Digitalisierung und zentrales IT-Management der Landesregierung
 *
 * Lizenziert unter der EUPL, Version 1.2 oder - sobald
 * diese von der Europäischen Kommission genehmigt wurden -
 * Folgeversionen der EUPL ("Lizenz");
 * Sie dürfen dieses Werk ausschließlich gemäß
 * dieser Lizenz nutzen.
 * Eine Kopie der Lizenz finden Sie hier:
 *
 * https://joinup.ec.europa.eu/collection/eupl/eupl-text-eupl-12
 *
 * Sofern nicht durch anwendbare Rechtsvorschriften
 * gefordert oder in schriftlicher Form vereinbart, wird
 * die unter der Lizenz verbreitete Software "so wie sie
 * ist", OHNE JEGLICHE GEWÄHRLEISTUNG ODER BEDINGUNGEN -
 * ausdrücklich oder stillschweigend - verbreitet.
 * Die sprachspezifischen Genehmigungen und Beschränkungen
 * unter der Lizenz sind dem Lizenztext zu entnehmen.
 */
package de.ozgcloud.vorgang.vorgang;

import java.util.Map;
import java.util.UUID;

import de.ozgcloud.vorgang.common.grpc.GrpcSubFormTestFactory;

public class EingangTestFactory {

	public static final String ID = UUID.randomUUID().toString();

	public static final String SINGLE_FIELD_LABEL = GrpcSubFormTestFactory.FIELD_LABEL;
	public static final String SINGLE_FIELD_NAME = GrpcSubFormTestFactory.FIELD_NAME;
	public static final String SINGLE_FIELD_VALUE = GrpcSubFormTestFactory.FIELD_VALUE;
	public static final Map<String, Object> SINGLE_FIELD = GrpcSubFormTestFactory.FIELD;

	public static final String SUBFORM_LABEL = GrpcSubFormTestFactory.SUBFORM_LABEL;
	public static final String SUBFORM_NAME = GrpcSubFormTestFactory.SUBFORM_TITLE;

	public static final String SUBFORM_FIELD_LABEL = GrpcSubFormTestFactory.SUBFORM_FIELD_LABEL;
	public static final String SUBFORM_FIELD_NAME = GrpcSubFormTestFactory.SUBFORM_FIELD_NAME;
	public static final String SUBFORM_FIELD_VALUE = GrpcSubFormTestFactory.SUBFORM_FIELD_VALUE;
	public static final Map<String, Object> SUBFORM_FIELD = GrpcSubFormTestFactory.SUBFORM_FIELD;

	public static final Map<String, Object> SUBFORM = GrpcSubFormTestFactory.SUBFORM;
	public static final Map<String, Object> SUBFORM_FLAT = Map.of(SUBFORM_FIELD_NAME, SUBFORM_FIELD);
	public static final Map<String, Object> FORM_DATA = Map.of(SINGLE_FIELD_NAME, SINGLE_FIELD, SUBFORM_NAME, SUBFORM);

	public static Eingang create() {
		return createBuilder().build();
	}

	public static Eingang.EingangBuilder createBuilder() {
		return Eingang.builder()
				.id(ID)
				.header(EingangHeaderTestFactory.create())
				.antragsteller(AntragstellerTestFactory.create())
				.formData(FORM_DATA)
				.attachment(IncomingFileGroupTestFactory.create())
				.representation(IncomingFileTestFactory.create())
				.zustaendigeStelle(ZustaendigeStelleTestFactory.create());
	}
}